# Multi-dataref query test program for the Python client library

#------------------------------------------------------------------------------

if __name__ == "__main__":
    import sys
    import time
    from xplra import XPlane, ProtocolException

    xplane = XPlane()

    dontregister = "dontregister" in sys.argv

    try:
        print "Connecting to X-Plane..."
        xplane.connect()
        print "Connected to X-Plane."
        print

        setter = xplane.createMultiSetter()

        simSpeedID = setter.addInt("sim/time/sim_speed")
        zuluSecID = setter.addFloat("sim/time/zulu_time_sec")
        localXID = setter.addDouble("sim/flightmodel/position/local_x")
        tailNumID = setter.addByteArray("sim/aircraft/view/acf_tailnum", 40)
        generatorOnID = setter.addIntArray("sim/cockpit/electrical/generator_on", 8)
        propPitchID = setter.addFloatArray("sim/cockpit2/engine/actuators/prop_pitch_deg", 2)

        if dontregister:
            setter.finalize()
        else:
            print "Registering setter..."
            setter.register();
            print "Registered setter"
            print

        print "Setting values..."

        setter[simSpeedID] = 0
        setter[zuluSecID] = 7265.0
        setter[localXID] = 12.0
        setter[tailNumID] = "Kukutyin"
        setter[generatorOnID] =[ 1, 0, 1, 0, 1, 0, 1 , 0 ]
        setter[propPitchID] = [ 32.4, 78.2 ]

        print "Executing..."

        setter.execute()

        print "Done."

    except Exception as e:
        print ">>>>>>>>>>>>>>>>>>>>>> Exception caught:", str(e)
    finally:
        xplane.disconnect()
